commit 0e10d6eb51c37b745f6105089dba7115c7e303da
Author: berryc <berryc>
Date:   Sun Jun 27 23:58:12 2010 +0000

    Zero local password memory after setting internal structures.
    idea from Christos Zoulas <christos@zoulas.com>

diff --git a/ChangeLog b/ChangeLog
index 7d1ce87..f03c98d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Sun Jun 27 18:51:00 CDT 2010	Craig A. Berry <craigberry@mac.com>
+	* src/apps/bsqldb.c src/apps/bsqlodbc.c src/apps/defncopy.c
+	* src/apps/fisql/fisql.c src/apps/freebcp.c src/apps/tsql.c
+	- Zero local password memory after setting internal structures.
+	- idea from Christos Zoulas <christos@zoulas.com>
+
 Sun Jun 27 12:40:00 CDT 2010	Craig A. Berry <craigberry@mac.com>
 	* include/tds.h src/apps/tsql.c src/tds/iconv.c src/tds/locale.c
 	* src/tds/mem.c:
@@ -2521,4 +2527,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3041 2010/06/27 17:46:42 berryc Exp $
+$Id: ChangeLog,v 1.3042 2010/06/27 23:58:12 berryc Exp $
diff --git a/src/apps/bsqldb.c b/src/apps/bsqldb.c
index 883470b..c59db09 100644
--- a/src/apps/bsqldb.c
+++ b/src/apps/bsqldb.c
@@ -49,7 +49,7 @@
 #include <sybdb.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqldb.c,v 1.42 2010/05/21 15:18:49 freddy77 Exp $";
+static char software_version[] = "$Id: bsqldb.c,v 1.43 2010/06/27 23:58:12 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef _WIN32
@@ -827,6 +827,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 		case 'P':
 			got_password = 1;
 			DBSETLPWD(login, optarg);
+			memset(optarg, 0, strlen(optarg));
 			break;
 		case 'S':
 			options->servername = strdup(optarg);
diff --git a/src/apps/bsqlodbc.c b/src/apps/bsqlodbc.c
index bac6bda..39a0744 100644
--- a/src/apps/bsqlodbc.c
+++ b/src/apps/bsqlodbc.c
@@ -50,7 +50,7 @@
 #include <sqlext.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqlodbc.c,v 1.14 2010/02/07 21:55:54 jklowden Exp $";
+static char software_version[] = "$Id: bsqlodbc.c,v 1.15 2010/06/27 23:58:12 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char * next_query(void);
@@ -840,6 +840,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 			break;
 		case 'P':
 			login->password = strdup(optarg);
+			memset(optarg, 0, strlen(optarg));
 			break;
 		case 'S':
 			options->servername = strdup(optarg);
diff --git a/src/apps/defncopy.c b/src/apps/defncopy.c
index 7cfda75..2d04824 100644
--- a/src/apps/defncopy.c
+++ b/src/apps/defncopy.c
@@ -87,7 +87,7 @@ int getopt(int argc, const char *argv[], char *optstring);
 #endif
 #endif /* MicrosoftsDbLib */
 
-static char software_version[] = "$Id: defncopy.c,v 1.20 2010/06/26 23:47:02 berryc Exp $";
+static char software_version[] = "$Id: defncopy.c,v 1.21 2010/06/27 23:58:12 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifndef MicrosoftsDbLib
@@ -679,6 +679,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 			break;
 		case 'P':
 			DBSETLPWD(login, optarg);
+			memset(optarg, 0, strlen(optarg));
 			fdomain = FALSE;
 			break;
 		case 'S':
diff --git a/src/apps/fisql/fisql.c b/src/apps/fisql/fisql.c
index 8ba0189..3c2d0a9 100644
--- a/src/apps/fisql/fisql.c
+++ b/src/apps/fisql/fisql.c
@@ -450,6 +450,8 @@ main(int argc, char *argv[])
 		DBSETLUSER(login, username);
 	}
 	DBSETLPWD(login, password);
+	memset(password, 0, strlen(password));
+
 	if (char_set) {
 		DBSETLCHARSET(login, char_set);
 	}
diff --git a/src/apps/freebcp.c b/src/apps/freebcp.c
index 84c0965..7942cab 100644
--- a/src/apps/freebcp.c
+++ b/src/apps/freebcp.c
@@ -50,7 +50,7 @@
 #include <sybdb.h>
 #include "freebcp.h"
 
-static char software_version[] = "$Id: freebcp.c,v 1.54 2010/06/26 23:47:02 berryc Exp $";
+static char software_version[] = "$Id: freebcp.c,v 1.55 2010/06/27 23:58:12 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void pusage(void);
@@ -268,8 +268,10 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 				nl = strchr(pwd, '\n');
 				if(nl) *nl = '\0';
 				pdata->pass = strdup(pwd);
+				memset(pwd, 0, 255);
 			} else {
 				pdata->pass = strdup(optarg);
+				memset(optarg, 0, strlen(optarg));
 			}
 			break;
 		case 'i':
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 95c9b79..543bff4 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -87,7 +87,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.134 2010/06/27 17:46:43 berryc Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.135 2010/06/27 23:58:12 berryc Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -435,6 +435,7 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		case 'P':
 			free(password);
 			password = strdup(optarg);
+			memset(optarg, 0, strlen(optarg));
 			break;
 		case 'I':
 			free(confile);
@@ -581,6 +582,8 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		tds_set_passwd(login, password);
 	}
 
+	memset(password, 0, strlen(password));
+
 	/* free up all the memory */
 	free(confile);
 	free(hostname);

